#define STRICT

// Includes standard Windows
#include <windows.h>
#include <windowsx.h>
#include <time.h>
#include <stdlib.h>
#include <malloc.h>
#include <memory.h>
#include <stdio.h>

// Includes D3D
#define  D3D_OVERLOADS
#include <ddraw.h>
#include <d3d.h>
#include <d3dx.h>
#include "D3DEnum.h"

// Constantes
#include "const.h"

// Types
#include "types.h"

// Variables globales
HINSTANCE hInst;
LPDIRECTDRAW7			lpDD = NULL;				// Interface IDirectDraw7 
LPDIRECT3D7				lpD3D = NULL;				// Interface IDirect3D7 
LPDIRECTDRAWSURFACE7	lpddsRender = NULL;			// Surface Rendering
LPDIRECTDRAWSURFACE7	lpddsBackBuffer = NULL;		// Surface Backing store
LPDIRECTDRAWSURFACE7	g_pddsZBuffer    = NULL;	// Surface Z-buffer  
LPDIRECT3DDEVICE7		lpd3dDevice = NULL;			// Device D3D 
RECT					sRectangle;					// Rectangle courant
DDSURFACEDESC2			ddsd;
GUID gDeviceGUID;

BOOL bActive  = FALSE;								// Application active (non minimise)
BOOL bReady   = FALSE;								// Application prte  faire un render
BOOL bGrid	  = FALSE;								// Grille o/n

float fGridSize = 1.0;								// Pas de la grille

D3DVECTOR Observer( 0.0f, 0.0f, 9.0f ),				// Coord. observateur par dfaut
		  Target( 0.0f, 0.0f, 0.0f );				// Coord. cible par dfaut

D3DVECTOR Cursor1( 5.0f, -5.0f, 5.0f ),				// Coord. curseur 1 par dfaut
		  Cursor2( 1.0f, 1.0f, 1.0f ),				// Coord. curseur 2 par dfaut
		  Cursor3( -1.0f, -1.0f, -1.0f );			// Coord. curseur 3 par dfaut

D3DVECTOR vTracker;

D3DMATRIX	matView,								// Matrice camra
			matProj,								// Matrice camra
			matWorld;								// Matrice camra

float	fXmin = -10.,								// Espace de travail triview : X min
		fXmax = 10.,								// Espace de travail triview : X max
		fYmin = -10.,								// Espace de travail triview : Y min
		fYmax = 10.,								// Espace de travail triview : Y max
		fZmin = -10.,								// Espace de travail triview : Z min
		fZmax = 10.;								// Espace de travail triview : Z max

Gadget	gAddPoint,									// Gadget Sculpt3D : Ajouter point
		gCenter,									// Gadget Sculpt3D : Centrer la vue sur le curseur
		gGoDown,									// Gadget Sculpt3D : Descendre (dans la vue courante)
		gGoLeft,									// Gadget Sculpt3D : Aller  gauche (idem)
		gGoUp,										// Gadget Sculpt3D : Monter (idem)
		gGoRight,									// Gadget Sculpt3D : Aller  droite (idem)
		gGrab,										// Gadget Sculpt3D : Activer pince
		gMakeTri,									// Gadget Sculpt3D : Crer triangle (entre les 3 curseurs)
		gReverse,									// Gadget Sculpt3D : ???
		gRotAnti,									// Gadget Sculpt3D : Rotation anti clockwise
		gRotClock,									// Gadget Sculpt3D : Rotation clockwise
		gZoomIn,									// Gadget Sculpt3D : Zoomer en avant
		gZoomOut;									// Gadget Sculpt3D : Zoomer en arrire

HWND	hWndPersp,									// Handle fentre vue 3D
		hWndTop,									// Handle fentre vue de dessus
		hWndFace,									// Handle fentre vue de face
		hWndRight,									// Handle fentre vue de droite
		hWndMenu,									// Handle fentre menu
		hWndTrace;									// Handle sous-fentre listbox trace

gSommet Vertices[XDC_NUMPT];						// Tableau global de points
gEdge	Edges[XDC_NUMEDGE];							// Tableau global de segments
gTri	Triangles[XDC_NUMTRI];						// Tableau global de triangles
gLamp	Lampes[XDC_NUMLAMP];						// Tableau global de lampes
gObject	Objects[XDC_NUMOBJECTS];
gMtrl	Materials[XDC_NUMMTRL];

int iVertLastUsed = -1, iVertFirstAvailable = 0;
int iEdgeLastUsed = -1, iEdgeFirstAvailable = 0;
int iTriaLastUsed = -1, iTriaFirstAvailable = 0;
int iLampLastUsed = -1, iLampFirstAvailable = 0;
int iObjtLastUsed = -1, iObjtFirstAvailable = 0;
int iMtrlLastUsed = -1, iMtrlFirstAvailable = 0;

BOOL bCoords = FALSE;								// Afficher les coordonnes o/n

D3DCOLOR	cAmbient = 0xffffffff,					// Couleur lumire ambiante
			cBack = 0x00000050;						// Couleur arrire plan

DWORD dFillMode = D3DFILL_SOLID;					// Mode de dessin 3D par dfaut (point, fil, face)
DWORD dZBuf = D3DZB_TRUE;							// Z-Buffer (o/n)
BOOL  bAlpha = FALSE;								// Alpha blending o/n
BOOL  bSpecular = FALSE;
DWORD dCull = D3DCULL_CCW;
BOOL bAntialias = TRUE;

char *sLogo = "wcLogo";								// Nom de la classe de fentre logo
char *sMenu = "wcMenu";								// Nom de la classe de fentre menu
char *sPersp = "wcPersp";							// Nom de la classe de fentre 3D
char *sPlanar = "wcPlanar";							// Nom de la classe de fentre 2D

char cTool = XDC_TOOL_NONE;							// Outil courant : NONE, GRAB, SELECT, CURVE, MAGNET

D3DEnum_DeviceInfo *m_pDeviceInfo;

char cTitle[255], cString[255];

long lWActive;										// HWND de la fentre 2D active (face, top, right)

int iHoles;											// Nombre de trous dans une courbe  trianguler
HWND hHoleDlgActive = NULL;							// Boolen indiquant  la proc de gestion des fentres 2D si les clics doivent tre passs  la dlgproc de gestion des trous dans le fill pour les identifier
double dHoles[XDC_MAX_HOLES * 2];					// suite de iHoles couples XY des trous
SMALLBOOL bFillAndRemoveEdges = TRUE;				// Si TRUE, fill() doit supprimer les artes aprs triangulation d'une courbe
